package hatenahaiku4j.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

/**
 * Ɋւ郆[eBeBNX
 * 
 * @since v0.0.1
 * @author fumokmm
 */
public class DateUtil {
	/** TimeZone(JST) */
	static final TimeZone TZ_GMT0 = TimeZone.getTimeZone("GMT+00");
	/** TimeZone(JST) */
	static final TimeZone TZ_JST = TimeZone.getTimeZone("GMT+09");
	/** datetimeTZ`tH[}b^[ */
	private static final DateFormat TZFormatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");

	/**
	 * datetimeTZ`Dateɕϊ
	 * 
	 * @param datetimeTZ datetimeTZ`̕
	 * @return {WDate
	 * @throws ParseException 
	 * @since v0.0.1
	 */
	public static Date toJSTDate(String datetimeTZ) throws ParseException {
	    TZFormatter.setTimeZone(TZ_GMT0);
	    return adjustToJST(TZFormatter.parse(datetimeTZ));
	}

	/**
	 * DatedatetimeTZ`ɕϊ
	 * 
	 * @param defaultDate {WDate
	 * @return datetimeTZ`̕
	 * @since v0.0.1
	 */
	public static String toDefaultTZ(Date defaultDate) {
	    TZFormatter.setTimeZone(TZ_GMT0);
	    return TZFormatter.format(adjustToDefault(defaultDate));
	}

	/**
	 * {W̌ݎDate擾܂B
	 * 
	 * @since v0.0.1
	 */
	public static Date getNow() {
		return adjustToJST(new Date());
	}

	/**
	 * {ԂɂȂ悤AԂ𒲐܂B(GMT+0JST(GMT+09))
	 * 
	 * @since v0.0.1
	 */
	static Date adjustToJST(Date date) {
		Date newDate = new Date();
		newDate.setTime(date.getTime() - TimeZone.getDefault().getRawOffset());
		newDate.setTime(newDate.getTime() + TZ_JST.getRawOffset());
		return newDate;
	}

	/**
	 * GMT+0ɂȂ悤AԂ𒲐܂B(JST(GMT+09)GMT+0)
	 * 
	 * @since v0.0.1
	 */
	static Date adjustToDefault(Date date) {
		Date newDate = new Date();
		newDate.setTime(date.getTime() - TZ_JST.getRawOffset());
		newDate.setTime(newDate.getTime() + TimeZone.getDefault().getRawOffset());
		return newDate;
	}
}
