package hatenahaiku4j;

import hatenahaiku4j.util.HttpUtil;
import hatenahaiku4j.util.StringUtil;
import hatenahaiku4j.util.XmlUtil;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.List;

import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

/**
 * ͂ĂȃnCNAPIbsONXiF؂j
 * 
 * @see <a href="http://h.hatena.ne.jp/api">͂ĂȃnCNAPI</a>
 * @since v0.0.1
 * @author fumokmm
 */
public class HatenaHaikuAPI extends HatenaHaikuAPILight {
	/** URL: th^CC(XML) */
	protected static final String URL_FRIENDS_TIMELINE_XML			= "http://h.hatena.ne.jp/api/statuses/friends_timeline.xml";
	/** URL: [U^CC(XML) */
	protected static final String URL_USER_TIMELINE_XML				= "http://h.hatena.ne.jp/api/statuses/user_timeline.xml";
	/** URL: e(XML) */
	protected static final String URL_UPDATE_STATUS_XML				= "http://h.hatena.ne.jp/api/statuses/update.xml";
	/** URL: Gg폜 */
	protected static final String URL_DELETE_STATUS					= "http://h.hatena.ne.jp/api/statuses/destroy/";
	/** URL: GgɃX^[ǉ */
	protected static final String URL_ADD_STAR						= "http://h.hatena.ne.jp/api/favorites/create/";
	/** URL: Gg̃X^[炷 */
	protected static final String URL_DELETE_STAR					= "http://h.hatena.ne.jp/api/favorites/destroy/";
	/** URL: [UtH[Ă郆[ŨXg(XML) */
	protected static final String URL_FOLLOWING_LIST_XML			= "http://h.hatena.ne.jp/api/statuses/friends.xml";
	/** URL: [UtH[Ă郆[ŨXg(XML) */
	protected static final String URL_FOLLOWERS_LIST_XML			= "http://h.hatena.ne.jp/api/statuses/followers.xml";
	/** URL: [UtH[ */
	protected static final String URL_FOLLOW_USER					= "http://h.hatena.ne.jp/api/friendships/create/";
	/** URL: [ŨtH[߂ */
	protected static final String URL_UNFOLLOW_USER					= "http://h.hatena.ne.jp/api/friendships/destroy/";
	/** URL: [UtH[ĂL[[h̃Xg(XML) */
	protected static final String URL_FOLLOWING_KEYWORD_LIST_XML	= "http://h.hatena.ne.jp/api/statuses/keywords.xml";
	/** URL: L[[htH[ */
	protected static final String URL_FOLLOW_KEYWORD				= "http://h.hatena.ne.jp/api/keywords/create/";
	/** URL: L[[h̃tH[߂ */
	protected static final String URL_UNFOLLOW_KEYWORD				= "http://h.hatena.ne.jp/api/keywords/destroy/";
	/** URL: ֘AL[[hݒ(XML) */
	protected static final String URL_RELATE_KEYWORD_XML			= "http://h.hatena.ne.jp/api/keywords/relation/create.xml";
	/** URL: ֘AL[[h(XML) */
	protected static final String URL_UNRELATE_KEYWORD_XML			= "http://h.hatena.ne.jp/api/keywords/relation/destroy.xml";

	/** OC[U */
	private LoginUser loginUser;
	
	/**
	 * RXgN^B
	 * 
	 * @param loginUser OC[U
	 * @since v0.0.1
	 */
	public HatenaHaikuAPI(LoginUser loginUser) {
		super();
		this.loginUser = loginUser;
	}

	//-------------------------------------------------------------
	// statuses/timeline
	//-------------------------------------------------------------

	/**
	 * F؂[Ũth^CC擾܂BŐVy[W20擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends_timeline">statuses/friends_timeline</a>
	 * @return F؂[Ũth^CC
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public List<Status> getFriendsTimeline() throws HatenaHaikuException {
		return getFriendsTimeline(0, 0, null);
	}

	/**
	 * F؂[Ũth^CC擾܂B擾20łB<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends_timeline">statuses/friends_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @return F؂[Ũth^CC
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public List<Status> getFriendsTimeline(int page) throws HatenaHaikuException {
		return getFriendsTimeline(page, 0, null);
	}

	/**
	 * F؂[Ũth^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends_timeline">statuses/friends_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @return F؂[Ũth^CC
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public List<Status> getFriendsTimeline(int page, int count) throws HatenaHaikuException {
		return getFriendsTimeline(page, count, null);
	}

	/**
	 * F؂[Ũth^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends_timeline">statuses/friends_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @return F؂[Ũth^CC
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public List<Status> getFriendsTimeline(int page, int count, Date since) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setPage(page);
			param.setCount(count);
			param.setSince(since);
			String resultXml = HttpUtil.doGet(loginUser, URL_FRIENDS_TIMELINE_XML, param, isNeedHttpLog());
			return toStatusList(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	/**
	 * F؂[Ũ[U^CC擾܂BŐVy[W20擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/user_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @return F؂[Ũ[U^CC
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public List<Status> getUserTimeline() throws HatenaHaikuException {
		return _getUserTimeline(0, 0, null, false);
	}

	/**
	 * F؂[Ũ[U^CC擾܂B擾20łB<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/user_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @return F؂[Ũ[U^CC
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public List<Status> getUserTimeline(int page) throws HatenaHaikuException {
		return _getUserTimeline(page, 0, null, false);
	}

	/**
	 * F؂[Ũ[U^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/user_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @return F؂[Ũ[U^CC
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public List<Status> getUserTimeline(int page, int count) throws HatenaHaikuException {
		return _getUserTimeline(page, count, null, false);
	}

	/**
	 * F؂[Ũ[U^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/user_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @return F؂[Ũ[U^CC
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public List<Status> getUserTimeline(int page, int count, Date since) throws HatenaHaikuException {
		return _getUserTimeline(page, count, since, false);
	}

	/**
	 * F؂[U̐lC̃[U^CC擾܂BŐVy[W20擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/user_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @return F؂[U̐lC̃[U^CC
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public List<Status> getHotUserTimeline() throws HatenaHaikuException {
		return _getUserTimeline(0, 0, null, true);
	}

	/**
	 * F؂[U̐lC̃[U^CC擾܂B擾20łB<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/user_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @return F؂[U̐lC̃[U^CC
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public List<Status> getHotUserTimeline(int page) throws HatenaHaikuException {
		return _getUserTimeline(page, 0, null, true);
	}

	/**
	 * F؂[U̐lC̃[U^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/user_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @return F؂[U̐lC̃[U^CC
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public List<Status> getHotUserTimeline(int page, int count) throws HatenaHaikuException {
		return _getUserTimeline(page, count, null, true);
	}

	/**
	 * F؂[U̐lC̃[U^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/user_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @return F؂[U̐lC̃[U^CC
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public List<Status> getHotUserTimeline(int page, int count, Date since) throws HatenaHaikuException {
		return _getUserTimeline(page, count, since, true);
	}
	
	/**
	 * F؂[Ũ[U^CC擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/user_timeline.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-user_timeline">statuses/user_timeline</a>
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @param isHot lC擾pǂ
	 * @return F؂[Ũ[U^CC
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	private List<Status> _getUserTimeline(int page, int count, Date since, boolean isHot) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter(isHot);
			param.setPage(page);
			param.setCount(count);
			param.setSince(since);
			String resultXml = HttpUtil.doGet(loginUser, URL_USER_TIMELINE_XML, param, isNeedHttpLog());
			return toStatusList(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	/**
	 * F؂[Uidy[W̃^CC擾܂BŐVy[W20擾܂B<br/>
	 * ̃^CC "id:xxxx" ̃L[[h^CCƓ̂łB
	 * 
	 * @see HatenaHaikuAPILight#getKeywordTimeline(String)
	 * @return F؂[Uidy[W̃^CC
	 * @throws HatenaHaikuException
	 * @since v0.2.0
	 */
	public List<Status> getIdTimeline() throws HatenaHaikuException {
		return getKeywordTimeline(loginUser.getUserIdNotation(), 0, 0, null);
	}

	/**
	 * F؂[Uidy[W̃^CC擾܂B擾20łB<br/>
	 * ̃^CC "id:xxxx" ̃L[[h^CCƓ̂łB
	 * 
	 * @see HatenaHaikuAPILight#getKeywordTimeline(String, int)
	 * @param page 擾y[WłBő吔100łB
	 * @return F؂[Uidy[W̃^CC
	 * @throws HatenaHaikuException
	 * @since v0.2.0
	 */
	public List<Status> getIdTimeline(int page) throws HatenaHaikuException {
		return getKeywordTimeline(loginUser.getUserIdNotation(), page, 0, null);
	}

	/**
	 * F؂[Uidy[W̃^CC擾܂B<br/>
	 * ̃^CC "id:xxxx" ̃L[[h^CCƓ̂łB
	 * 
	 * @see HatenaHaikuAPILight#getKeywordTimeline(String, int, int)
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @return F؂[Uidy[W̃^CC
	 * @throws HatenaHaikuException
	 * @since v0.2.0
	 */
	public List<Status> getIdTimeline(int page, int count) throws HatenaHaikuException {
		return getKeywordTimeline(loginUser.getUserIdNotation(), page, count, null);
	}

	/**
	 * F؂[Uidy[W̃^CC擾܂B<br/>
	 * ̃^CC "id:xxxx" ̃L[[h^CCƓ̂łB
	 * 
	 * @see HatenaHaikuAPILight#getKeywordTimeline(String, int, int, Date)
	 * @param page 擾y[WłBő吔100łB
	 * @param count 擾w肵܂Bő吔 200 łB
	 * @param since ̓Vê݂ɍi荞ނ߂̓w肵܂B
	 * @return F؂[Uidy[W̃^CC
	 * @throws HatenaHaikuException
	 * @since v0.2.0
	 */
	public List<Status> getIdTimeline(int page, int count, Date since) throws HatenaHaikuException {
		return getKeywordTimeline(loginUser.getUserIdNotation(), page, count, since);
	}
	
	//-------------------------------------------------------------
	// Xe[^X֌W
	//-------------------------------------------------------------

	/**
	 * VGg𓊍e܂BiOC[ŨvtB[y[Wɓe܂j
	 * 
	 * @param text ee
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public Status entry(String text) throws HatenaHaikuException {
		UpdateParameter params = new UpdateParameter();
		params.setText(text);
		return _updateStatus(params);
	}

	/**
	 * VGg𓊍e܂B
	 * 
	 * @param keyword L[[h
	 * @param text ee
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public Status entry(String keyword, String text) throws HatenaHaikuException {
		UpdateParameter params = new UpdateParameter();
		params.setKeyword(keyword);
		params.setText(text);
		return _updateStatus(params);
	}

	/**
	 * VGg𓊍e܂B<br/>
	 * 摜tŃGg܂B
	 * 
	 * @param keyword L[[h
	 * @param text ee
	 * @param file 摜t@C
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public Status entry(String keyword, String text, File file) throws HatenaHaikuException {
		UpdateParameter params = new UpdateParameter();
		params.setKeyword(keyword);
		params.setText(text);
		params.setFile(file);
		return _updateStatus(params);
	}
	
	/**
	 * VGg𓊍e܂B<br/>
	 * URLɂ摜tŃGg܂B
	 * 
	 * @param keyword L[[h
	 * @param text ee
	 * @param imageUrl 摜URL
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public Status entry(String keyword, String text, String imageUrl) throws HatenaHaikuException {
		UpdateParameter params = new UpdateParameter();
		params.setKeyword(keyword);
		params.setText(text);
		params.setImageUrl(imageUrl);
		return _updateStatus(params);
	}

	/**
	 * VGg𓊍e܂B<br/>
	 * 摜̃oCif[^Ƃ̊gqw肵A摜tŃGg܂B
	 * 
	 * @param keyword L[[h
	 * @param text ee
	 * @param imageData 摜̃oCif[^
	 * @param imageDataExt 摜̊gq
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public Status entry(String keyword, String text, byte[] imageData, ImageExt imageDataExt) throws HatenaHaikuException {
		UpdateParameter params = new UpdateParameter();
		params.setKeyword(keyword);
		params.setText(text);
		params.setImageData(imageData);
		params.setImageDataExt(imageDataExt);
		return _updateStatus(params);
	}

	/**
	 * VԐMGg𓊍e܂B
	 * 
	 * @param inReplyToStatusId ԐMXe[^XID
	 * @param text ee
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public Status reply(String inReplyToStatusId, String text) throws HatenaHaikuException {
		UpdateParameter params = new UpdateParameter();
		params.setInReplyToStatusId(inReplyToStatusId);
		params.setText(text);
		return _updateStatus(params);
	}

	/**
	 * VԐMGg𓊍e܂B<br/>
	 * 摜tŃGg܂B
	 * 
	 * @param inReplyToStatusId ԐMXe[^XID
	 * @param text ee
	 * @param file 摜t@C
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public Status reply(String inReplyToStatusId, String text, File file) throws HatenaHaikuException {
		UpdateParameter params = new UpdateParameter();
		params.setInReplyToStatusId(inReplyToStatusId);
		params.setText(text);
		params.setFile(file);
		return _updateStatus(params);
	}

	/**
	 * VԐMGg𓊍e܂B<br/>
	 * URLɂ摜tŃGg܂B
	 * 
	 * @param inReplyToStatusId ԐMXe[^XID
	 * @param text ee
	 * @param imageUrl 摜URL
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public Status reply(String inReplyToStatusId, String text, String imageUrl) throws HatenaHaikuException {
		UpdateParameter params = new UpdateParameter();
		params.setInReplyToStatusId(inReplyToStatusId);
		params.setText(text);
		params.setImageUrl(imageUrl);
		return _updateStatus(params);
	}

	/**
	 * VԐMGg𓊍e܂B<br/>
	 * 摜̃oCif[^Ƃ̊gqw肵A摜tŃGg܂B
	 * 
	 * @param inReplyToStatusId ԐMXe[^XID
	 * @param text ee
	 * @param imageData 摜̃oCif[^
	 * @param imageDataExt 摜̊gq
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException
	 * @since v1.0.0
	 */
	public Status reply(String inReplyToStatusId, String text, byte[] imageData, ImageExt imageDataExt) throws HatenaHaikuException {
		UpdateParameter params = new UpdateParameter();
		params.setInReplyToStatusId(inReplyToStatusId);
		params.setText(text);
		params.setImageData(imageData);
		params.setImageDataExt(imageDataExt);
		return _updateStatus(params);
	}

	/**
	 * ͂ĂȃnCNɓe܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/update.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-update">statuses/update</a>
	 * @param params XVp[^
	 * @return eʂ̃Xe[^X
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	private Status _updateStatus(UpdateParameter param) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doPost(loginUser, URL_UPDATE_STATUS_XML, param, isNeedHttpLog());
			return toStatus(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * w肵Xe[^XID̃Gg폜܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/destroy/<font color="red">Xe[^XID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-destroy">statuses/destroy</a>
	 * @param statusId Xe[^XID
	 * @return 폜Xe[^X
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public Status deleteEntry(String statusId) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(loginUser, URL_DELETE_STATUS + statusId + Const.EXT_XML, null, isNeedHttpLog());
			return toStatus(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	//-------------------------------------------------------------
	// X^[֌W
	//-------------------------------------------------------------

	/**
	 * w肵GgɃX^[ǉ܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/favorites/create/<font color="red">Xe[^XID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#favorites-create">favorites/create</a>
	 * @param statusId Xe[^XID
	 * @return X^[ǉʂ̃Xe[^X
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public Status addStar(String statusId) throws HatenaHaikuException {
		return _modifyStar(true, statusId);
	}

	/**
	 * w肵Gg̃X^[炵܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/favorites/destroy/<font color="red">Xe[^XID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#favorites-destroy">favorites/destroy</a>
	 * @param statusId Xe[^XID
	 * @return X^[炵ʂ̃Xe[^X
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public Status deleteStar(String statusId) throws HatenaHaikuException {
		return _modifyStar(false, statusId);
	}
	
	/**
	 * w肵Gg̃X^[₵茸炵肵܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/favorites/destroy/<font color="red">Xe[^XID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#favorites-destroy">favorites/destroy</a>
	 * @param isAdd true:₷^false:炷
	 * @param statusId Xe[^XID
	 * @return X^[₵茸炵肵ʂ̃Xe[^X
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	private Status _modifyStar(boolean isAdd, String statusId) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(loginUser, (isAdd ? URL_ADD_STAR : URL_DELETE_STAR) + statusId + Const.EXT_XML, null, isNeedHttpLog());
			return toStatus(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	//-------------------------------------------------------------
	// [U^tH[֌W
	//-------------------------------------------------------------

	/**
	 * F؂[UtH[Ă郆[ŨXg100擾܂BiPy[Wځj<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends">statuses/friends</a>
	 * @return F؂[UtH[Ă郆[ŨXgiPy[Wځj
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public List<User> getFollowingList() throws HatenaHaikuException {
		return getFollowingList(1);
	}

	/**
	 * F؂[UtH[Ă郆[ŨXg100擾܂Biwy[Wj<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/friends.xml&page=<font color="red">y[W</font></i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-friends">statuses/friends</a>
	 * @param page y[W
	 * @return F؂[UtH[Ă郆[ŨXgiwy[Wj
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public List<User> getFollowingList(int page) throws HatenaHaikuException {
		try {
			QueryParameter param = new QueryParameter();
			param.setPage(page);
			String resultXml = HttpUtil.doGet(loginUser, URL_FOLLOWING_LIST_XML, param, isNeedHttpLog());
			return toUserList(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * F؂[UtH[Ă郆[ŨXg擾܂B<br/>
	 * tH[̓y[WwłACɑS擾悤łB<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/followers.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-followers">statuses/followers</a>
	 * @return F؂[UtH[Ă郆[ŨXg
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public List<User> getFollowersList() throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(loginUser, URL_FOLLOWERS_LIST_XML, null, isNeedHttpLog());
			return toUserList(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * [UtH[܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/friendships/create/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#friendships-create">friendships/create</a>
	 * @param userId [UID
	 * @return tH[[U
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public User followUser(String userId) throws HatenaHaikuException {
		return _modifyFollowUser(true, userId);
	}

	/**
	 * [ŨtH[߂܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/friendships/destroy/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#friendships-destroy">friendships/destroy</a>
	 * @param userId [UID
	 * @return tH[߂[U
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public User unfollowUser(String userId) throws HatenaHaikuException {
		return _modifyFollowUser(false, userId);
	}
	
	/**
	 * [ŨtH[߂肵܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/friendships/destroy/<font color="red">[UID</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#friendships-destroy">friendships/destroy</a>
	 * @param isFollow true:tH[^false:tH[߂
	 * @param userId [UID
	 * @return tH[߂肵[U
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	private User _modifyFollowUser(boolean isFollow, String userId) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(loginUser, (isFollow ? URL_FOLLOW_USER : URL_UNFOLLOW_USER) + userId + Const.EXT_XML, null, isNeedHttpLog());
			return toUser(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}
	
	/**
	 * OC[Ũ[U擾܂B<br/>
	 * 
	 * @see HatenaHaikuAPILight#getUser(String)
	 * @return OC[Ũ[U
	 * @throws HatenaHaikuException
	 * @since v0.2.0
	 */
	public User getMe() throws HatenaHaikuException {
		return getUser(loginUser.getUserId());
	}

	//-------------------------------------------------------------
	// L[[h֌W
	//-------------------------------------------------------------

	/**
	 * F؂[UtH[ĂL[[h̃Xg擾܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/statuses/keywords.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#statuses-keywords">statuses/keywords</a>
	 * @return@F؂[UtH[ĂL[[hXg
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public List<Keyword> getFollowingKeywordList() throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(loginUser, URL_FOLLOWING_KEYWORD_LIST_XML, null, isNeedHttpLog());
			return toKeywordList(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * L[[htH[܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/create/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-create">keywords/create</a>
	 * @param keyword L[[h
	 * @return tH[L[[h
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public Keyword followKeyword(String keyword) throws HatenaHaikuException {
		return _modifyFollowKeyword(true, keyword);
	}

	/**
	 * L[[h̃tH[߂܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/destroy/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-destroy">keywords/destroy</a>
	 * @param keyword L[[h
	 * @return tH[߂L[[h
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public Keyword unfollowKeyword(String keyword) throws HatenaHaikuException {
		return _modifyFollowKeyword(false, keyword);
	}

	/**
	 * L[[h̃tH[A߂肵܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/destroy/<font color="red">L[[h</font>.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-destroy">keywords/destroy</a>
	 * @param isFollow true:tH[^false:tH[߂
	 * @param keyword L[[h
	 * @return tH[^߂L[[h
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	private Keyword _modifyFollowKeyword(boolean isFollow, String keyword) throws HatenaHaikuException {
		try {
			String resultXml = HttpUtil.doGet(loginUser, (isFollow ? URL_FOLLOW_KEYWORD : URL_UNFOLLOW_KEYWORD) + StringUtil.encode(keyword) + Const.EXT_XML, null, isNeedHttpLog());
			return toKeyword(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * ֘AL[[hݒ肵܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/relation/create.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-relation-create">keywords/relation/create</a>
	 * @param keyword1 ݒ肷Ώۂ̃L[[hP
	 * @param keyword2 ݒ肷Ώۂ̃L[[hQ
	 * @return ֘AL[[hݒ̃L[[hP̃L[[h
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public Keyword relateKeyword(String keyword1, String keyword2) throws HatenaHaikuException {
		return _modifyRelateKeyword(true, keyword1, keyword2);
	}

	/**
	 * ֘AL[[h܂B<br/>
	 * ֘AL[[h̐ݒ̍폜͎ݒ肵̂Ɍ܂B<br/>
	 * <i>http://h.hatena.ne.jp/api/keywords/relation/destroy.xml</i>
	 * 
	 * @see <a href="http://h.hatena.ne.jp/api#keywords-relation-destroy">keywords/relation/destroy</a>
	 * @param keyword1 Ώۂ̃L[[hP
	 * @param keyword2 Ώۂ̃L[[hQ
	 * @return ֘AL[[h̃L[[hP̃L[[h
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	public Keyword unrelateKeyword(String keyword1, String keyword2) throws HatenaHaikuException {
		return _modifyRelateKeyword(false, keyword1, keyword2);
	}
		
	/**
	 * ֘AL[[hݒ^
	 * 
	 * @param isRelate true:ݒ^false:
	 * @param keyword1 ΏۃL[[hP
	 * @param keyword2 ΏۃL[[hQ
	 * @return ֘AL[[hݒ^̃L[[hP̃L[[h
	 * @throws HatenaHaikuException
	 * @since v0.0.1
	 */
	private Keyword _modifyRelateKeyword(boolean isRelate, String keyword1, String keyword2) throws HatenaHaikuException {
		if (StringUtil.isSame(keyword1, keyword2)) {
			throw new HatenaHaikuException("ΏۃL[[hɓL[[h͎wł܂B");
		}
		try {
			QueryParameter param = new QueryParameter();
			param.setWord1(keyword1);
			param.setWord2(keyword2);
			String resultXml = HttpUtil.doGet(loginUser, (isRelate ? URL_RELATE_KEYWORD_XML : URL_UNRELATE_KEYWORD_XML), param, isNeedHttpLog());
			return toKeyword(XmlUtil.getRootElement(resultXml));

		} catch (ParserConfigurationException e) {
			throw new HatenaHaikuException("ParserConfigurationExceptionB", e);

		} catch (SAXException e) {
			throw new HatenaHaikuException("SAXExceptionB", e);

		} catch (IOException e) {
			throw new HatenaHaikuException("IOExceptionB", e);
		}
	}

	/**
	 * F؂[Uidy[W̃L[[h擾܂B<br/>
	 * 
	 * @see HatenaHaikuAPILight#getKeyword(String)
	 * @return F؂[Uidy[W̃L[[h
	 * @throws HatenaHaikuException
	 * @since v0.2.0
	 */
	public Keyword getMyKeyword() throws HatenaHaikuException {
		return getKeyword(loginUser.getUserIdNotation());
	}

	//----------------------------------
	// ȉAϊ\bh
	//----------------------------------
	
	/**
	 * Xe[^X̃CX^X擾܂B
	 * 
	 * @since v0.2.0
	 */
	@Override
	protected Status createStatus() {
		return Status.create(this);
	}

	/**
	 * [ŨCX^X擾܂B
	 * 
	 * @since v0.2.0
	 */
	@Override
	protected User createUser() {
		return User.create(this);
	}
	
	/**
	 * L[[h̃CX^X擾܂B
	 * 
	 * @since v0.2.0
	 */
	@Override
	protected Keyword createKeyword() {
		return Keyword.create(this);
	}
	
}
