package hatenahaiku4j.util;

import hatenahaiku4j.Const;
import hatenahaiku4j.HatenaHaikuException;
import hatenahaiku4j.ImageMime;
import hatenahaiku4j.LoginUser;
import hatenahaiku4j.QueryParameter;
import hatenahaiku4j.UpdateParameter;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.List;
import java.util.Map;

/**
 * HTTPNGXgɊւ郆[eBeBNX
 * 
 * @since v0.0.1
 * @author fumokmm
 */
public class HttpUtil {
	/** METHOD */
	private static enum Method { POST, GET }
	/** NGXgvpeBFBASICF */
	protected static final String REQUEST_PROPERTY_AUTHORIZATION = "Authorization";
	/** NGXgvpeB:RlNV */
	protected static final String REQUEST_PROPERTY_CONNECTION = "Connection";
	/** NGXgvpeB:RlNV (l:close) */
	protected static final String REQUEST_PROPERTY_CONNECTION_CLOSE = "close";
	/** NGXgvpeB:Reg^Cv */
	protected static final String REQUEST_PROPERTY_CONTENT_TYPE = "Content-Type";
	
	/**
	 * Qbg܂B
	 * 
	 * @param url NGXgURL
	 * @param param NGXgp[^
	 * @param needLog Oo͗v
	 * @return X|X{fB̕
	 * @throws MalformedURLException
	 * @throws IOException
	 * @since v0.0.1
	 */
	public static String doGet(String url, QueryParameter param, boolean needLog) throws MalformedURLException, IOException {
		return doGet(null, url, param, needLog);
	}

	/**
	 * Qbg܂B
	 * 
	 * @param loginUser OC[U
	 * @param url NGXgURL
	 * @param param NGXgp[^
	 * @param needLog Oo͗v
	 * @return X|X{fB̕
	 * @throws MalformedURLException
	 * @throws IOException
	 * @since v0.0.1
	 */
	public static String doGet(LoginUser loginUser, String url,
			QueryParameter param, boolean needLog) throws
			MalformedURLException, IOException {

		HttpURLConnection urlconn = null; // RlNV
		try {
			urlconn = (HttpURLConnection) new URL(url).openConnection();
			urlconn.setRequestMethod(Method.GET.name());
			if (loginUser != null) {
				urlconn.setRequestProperty(REQUEST_PROPERTY_AUTHORIZATION, loginUser.toBasicAuthenticationString());
			}
			// GETAoutputStream擾邽outputtrueƂ
			urlconn.setDoInput(true);		// for GET
			urlconn.setDoOutput(true);		// for POST
			urlconn.setUseCaches(false);	// disable cache
			// ŏɂčŌ̗v
			urlconn.setRequestProperty(REQUEST_PROPERTY_CONNECTION, REQUEST_PROPERTY_CONNECTION_CLOSE);
			
			// |Xge̕\
			if (param != null) {
				if (needLog) {
					param.outputPostInfo();
				}
			}

			OutputStream os = urlconn.getOutputStream();
			PostStream ps = new PostStream(os);
			if (param != null) {
				param.addParameter(ps);
			}
			ps.close();

			// X|X
			return getResponse(urlconn, needLog);

		} catch (MalformedURLException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} catch (IOException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} finally {
			// RlNVؒf
			urlconn.disconnect();
		}
	}

	/**
	 * |Xg܂B
	 * 
	 * @param loginUser OC[U
	 * @param url NGXgURL
	 * @param param NGXgp[^
	 * @param needLog Oo͗v
	 * @return X|X{fB̕
	 * @throws UnsupportedEncodingException
	 * @throws MalformedURLException
	 * @throws IOException
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public static String doPost(LoginUser loginUser, String url,
			UpdateParameter param, boolean needLog) throws UnsupportedEncodingException,
			MalformedURLException, IOException, HatenaHaikuException {

		HttpURLConnection urlconn = null; // RlNV
		try {
			urlconn = (HttpURLConnection) new URL(url).openConnection();
			urlconn.setRequestMethod(Method.POST.name());
			urlconn.setRequestProperty(REQUEST_PROPERTY_AUTHORIZATION, loginUser.toBasicAuthenticationString());
			// L[[hw̏ꍇ́AOC[UIDƂB
			if (param.getKeyword() == null || param.getKeyword().equals("")) {
				param.setKeyword(loginUser.getUserIdNotation());
			}
			// POST̂߁AInput/OutputƂtrue
			urlconn.setDoInput(true);		// for GET
			urlconn.setDoOutput(true);		// for POST
			urlconn.setUseCaches(false);	// disable cache
			// ŏɂčŌ̗v
			urlconn.setRequestProperty(REQUEST_PROPERTY_CONNECTION, REQUEST_PROPERTY_CONNECTION_CLOSE);

			// multipart/form-dataŃ|Xg邽߂̃oE_𐶐
			String boundary = "--------------------" + Const.API_NAME + StringUtil.getSerial();
			urlconn.setRequestProperty(REQUEST_PROPERTY_CONTENT_TYPE, "multipart/form-data; boundary=" + boundary);
			
			// |Xge̕\
			if (needLog) {
				param.outputPostInfo(loginUser);
			}

			OutputStream os = urlconn.getOutputStream();
			PostStream ps = new PostStream(os, boundary);
			param.addParameter(loginUser, ps);
			ps.close();
			
			// X|X
			return getResponse(urlconn, needLog);

		} catch (MalformedURLException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} catch (IOException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} finally {
			// RlNVؒf
			urlconn.disconnect();
		}
	}
	
	/**
	 * X|Xԋp܂B
	 * 
	 * @param urlconn@HTTPRlNV
	 * @param needLog Oo͗v
	 * @return X|X{fB̕
	 * @throws MalformedURLException
	 * @throws IOException
	 * @since v0.0.1
	 */
	private static String getResponse(HttpURLConnection urlconn, boolean needLog)
			throws MalformedURLException, IOException {

		try {
			// X|X
			Map<String, List<String>> headers = urlconn.getHeaderFields();
			if (needLog) {
				for (Map.Entry<String, List<String>> entry : headers.entrySet()) {
					System.out.println(entry.getKey() + ": " + entry.getValue());
				}
			}
			// {fB
			StringBuilder responseBody = new StringBuilder();
			BufferedReader responseReader = new BufferedReader(new InputStreamReader(urlconn.getInputStream(), Const.UTF8));
			String line;
			while((line = responseReader.readLine()) != null) {
				responseBody.append(line);
			}

			if (needLog) {
				System.out.println("----------------");
				System.out.println("X|XR[h: " + urlconn.getResponseCode());
				System.out.println("X|XbZ[W: " + urlconn.getResponseMessage());
				System.out.println("----------------");
				System.out.println(urlconn.getRequestMethod() + " successfully");
			}
			return responseBody.toString();

		} catch (IOException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} finally {
			// RlNVؒf
			urlconn.disconnect();
		}
	}
	
	/**
	 * |Xg⏕NXB<br/>
	 * p[^𐶐ă|Xg܂B
	 * 
	 * @author fumokmm
	 * @since v1.0.0
	 */
	public static class PostStream {
		/** f[^ݗp */
		protected final DataOutputStream out;
		/** eLXgݗp */
		protected final Writer wout;
		
		/** oE_[ */
		private final String boundary;
		/** Zp[^ */
		private static final String SEPARATOR = "--";
		/** s؂ */
		private static final byte[] CRLF = { 0x0d, 0x0a };
		/** obt@TCY */
		private final int BUFSIZE = 8192;

		/** f~^Kvǂ */
		private boolean needDelimeter = false;

		/**
		 * uURLGR[hv[h̃f[^Xg[쐬܂B<br>
		 * addProperty(java.lang.String, java.lang.String) Œǉf[^͓K؂ URL GR[h܂B<br>
		 * {@link #close()}ƁAContent-Type  "application/x-www-urlencoded" Ƃ POST NGXgs܂B
		 *
		 * @param o URLConnection.getOutputStream() ŕԂ {@link URLConnection#getOutputStream}
		 * @since v1.0.0
		 */
		public PostStream(OutputStream o) { 
		    this(o, null);
		}
		
		/**
		 * u}`p[gv[h̃f[^Xg[쐬܂B
		 * addProperty(java.lang.String, java.lang.String)
		 * addFile(java.io.File, java.lang.String, java.lang.String)
		 * ǉf[^̓}`p[g MIME `ɃtH[}bg܂B
		 * close() ƁAContent-Type  "multipart/form-data" Ƃ POST NGXgs܂B
		 *
		 * @param o {@link URLConnection#getOutputStream} ŕԂ OutputStream
		 * @param boundary }`p[g MIME ̋ؕ
		 * @since v1.0.0
		 */
		public PostStream(OutputStream o, String boundary) {
			if (o == null) {
				throw new NullPointerException("o is null.");
			}
			
			out = new DataOutputStream(o);

			Writer tmp_wout = null;
			try {
				tmp_wout = new OutputStreamWriter(out, Const.UTF8);
			} catch (UnsupportedEncodingException e) {
				// ignore it
		    } finally {
		    	wout = tmp_wout;
		    }

		    this.boundary = boundary;
		}

		/**
		 * p[^Xg[ɒǉ܂B
		 *
		 * @param name p[^
		 * @param value p[^̒l
		 * @throws IOException ݎɃG[
		 * @since v1.0.0
		 */
		public void addProperty(String name, String value) throws IOException {
			if (boundary == null) {
				if (needDelimeter) {
					wout.write('&');
				}
				String encoded = StringUtil.encode(name) + Const.EQUAL + StringUtil.encode(value);
				wout.write(encoded);
				wout.flush();
				needDelimeter = true;
				return;
			}
			writeSeparatorBoundary();
			writeContentDisposition(name);
			writeValue(value);
		}

		/**
		 * t@C̓eXg[ɒǉ܂B<br>
		 * u}`p[gv[h̃Xg[łgpł܂B
		 *
		 * @param file ǉt@C
		 * @param name p[^
		 * @param mimeType ̃t@C MIME ^Cv
		 * @throws IOException ʐMG[
		 * @since v1.0.0
		 */
		public void addFile(File file, String name, ImageMime mimeType) throws IOException {
			if (boundary == null) {
				throw new IllegalStateException("could not add a file for this stream.");
			}
			writeSeparatorBoundary();
			// t@C͂Ƃ肠Ȃł悤Ȃ̂ŁAmimeTypeHăt@CƂĂ
			writeContentDisposition(name, mimeType.toTemporaryFileName());
			writeContentType(mimeType.getMimeType());
			writeValue(file);
		}
		
		/**
		 * URLォoCgXg[擾At@CƂĒǉ܂B<br>
		 * u}`p[gv[h̃Xg[łgpł܂B
		 *
		 * @param imageUrl ǉt@C
		 * @param name p[^
		 * @param mimeType ̃t@C MIME ^Cv
		 * @throws IOException ʐMG[
		 * @since v1.0.0
		 */
		public void addImageUrl(String imageUrl, String name, ImageMime mimeType) throws IOException {
			if (boundary == null) {
				throw new IllegalStateException("could not add a image file for this stream.");
			}
			writeSeparatorBoundary();
			// t@C͂Ƃ肠Ȃł悤Ȃ̂ŁAmimeTypeHăt@CƂĂ
			writeContentDisposition(name, mimeType.toTemporaryFileName());
			writeContentType(mimeType.getMimeType());
			writeValue(new URL(imageUrl));
		}

		/**
		 * 摜oCif[^Xg[ɒǉ܂B<br>
		 * u}`p[gv[h̃Xg[łgpł܂B
		 *
		 * @param imageData 摜oCif[^
		 * @param name p[^
		 * @param mimeType ̃t@C MIME ^Cv
		 * @throws IOException ʐMG[
		 * @since v1.0.0
		 */
		public void addImageData(byte[] imageData, String name, ImageMime mimeType) throws IOException {
			if (boundary == null) {
				throw new IllegalStateException("could not add a image data for this stream.");
			}
			writeSeparatorBoundary();
			// t@C͂Ƃ肠Ȃł悤Ȃ̂ŁAmimeTypeHăt@CƂĂ
			writeContentDisposition(name, mimeType.toTemporaryFileName());
			writeContentType(mimeType.getMimeType());
			writeValue(imageData);
		}

		/**
		 * ̃Xg[āA|Xg܂B
		 * 
		 * @throws IOException
		 * @since v1.0.0
		 */
		public void close() throws IOException {
			if (boundary != null) {
				writeTerminate();
			}

			try {
				out.flush();
	    	} finally {
	    		try {
		    		if (out != null) {
						out.close();
		    		}
		    		if (wout != null) {
						wout.close();
		    		}
		    	} catch (Exception e) {
		    		// ignore it
		    	}
			}
		}
		
		/**
		 * Zp[^[{oE_[Xg[ɏ݂܂B
		 * 
		 * @throws IOException
		 * @since v1.0.0
		 */
		private void writeSeparatorBoundary() throws IOException {
			out.writeBytes(SEPARATOR);
			out.writeBytes(boundary);
			out.write(CRLF);
		}
		
		/**
		 * RegfBX|WVXg[ɏ݂܂B
		 * 
		 * @param name p[^
		 * @throws IOException
		 * @since v1.0.0
		 */
		private void writeContentDisposition(String name) throws IOException {
			wout.write("Content-Disposition: form-data; name=\"" + name + "\"");
			wout.flush();
			out.write(CRLF);
		}
		
		/**
		 * RegfBX|WVXg[ɏ݂܂B
		 * 
		 * @param name p[^
		 * @param fileName t@C
		 * @throws IOException
		 * @since v1.0.0
		 */
		private void writeContentDisposition(String name, String fileName) throws IOException {
			wout.write("Content-Disposition: form-data; name=\"" + name + "\"; filename=\"" + fileName + "\"");
			wout.flush();
			out.write(CRLF);
		}
		
		/**
		 * Rec^CvXg[ɏ݂܂B
		 * 
		 * @param mimeType }C^Cv
		 * @throws IOException
		 * @since v1.0.0
		 */
		private void writeContentType(String mimeType) throws IOException {
			wout.write("Content-Type: " + mimeType);
			wout.flush();
			out.write(CRLF);
		}
		
		/**
		 * Xg[ɏ݂܂B
		 * 
		 * @param value Xg[ɏޕ
		 * @throws IOException
		 * @since v1.0.0
		 */
		private void writeValue(String value) throws IOException {
			out.write(CRLF);
			wout.write(value);
			wout.flush();
			out.write(CRLF);
		}

		/**
		 * oCgzXg[ɏ݂܂B
		 * 
		 * @param value Xg[ɏރoCgz
		 * @throws IOException
		 * @since v1.0.0
		 */
		private void writeValue(byte[] value) throws IOException {
			out.write(CRLF);
			out.write(value, 0, value.length);
			out.write(CRLF);
		}
		
		/**
		 * t@CXg[ɏ݂܂B
		 * 
		 * @param file Xg[ɏރt@C
		 * @throws IOException
		 * @since v1.0.0
		 */
		private void writeValue(File file) throws IOException {
		    writeValue(FileUtil.toByteArray(file));
		}

		/**
		 * 
		 * @param imageUrl
		 * @throws IOException
		 * @since v1.0.0
		 */
		private void writeValue(URL imageUrl) throws IOException {
			InputStream in = null;
			ByteArrayOutputStream out = null;
		    try {
		    	in = imageUrl.openStream();
		    	out = new ByteArrayOutputStream();
		    	byte[] buffer = new byte[BUFSIZE];
		    	int rsize;
		    	while ((rsize = in.read(buffer)) != -1) {
		    		out.write(buffer, 0, rsize);
		    	}
		    } finally {
		    	try {
		    		if (in != null) {
		    			in.close();
		    		}
		    		if (out != null) {
		    			out.flush();
		    			out.close();
		    		}
		    	} catch (Exception e) {
		    	}
		    }
		    
		    writeValue(out.toByteArray());
		}
		
		/**
		 * 
		 * @throws IOException
		 * @since v1.0.0
		 */
		private void writeTerminate() throws IOException {
			out.writeBytes(SEPARATOR);
			out.writeBytes(boundary);
			out.writeBytes(SEPARATOR);
		}
	}
}
